#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Minecraft.ico
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <Crypt.au3>
#include <Array.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

;DllCall("kernel32.dll", "int", "Wow64DisableWow64FsRedirection", "int", 1)

Global $ConfigFile = @AppDataDir&"\.minecraft\Launcher.cfg"
Global $cmd =  '-Xms512m -Xmx1024m -cp "%APPDATA%\.minecraft\bin\*" -Djava.library.path="%APPDATA%\.minecraft\bin\natives" net.minecraft.client.Minecraft'
Global $mcupdate = _IniRead($ConfigFile,"Minecraft","Updatenews","http://mcupdate.tumblr.com/")
Global $mcdownload = "http://s3.amazonaws.com/MinecraftDownload/"
Global $gameFiles[4] = ["lwjgl.jar", "jinput.jar", "lwjgl_util.jar", "minecraft.jar"]
Global $natives = "windows_natives.jar.lzma"
Global $MCPath = _IniRead($ConfigFile,"Minecraft","Path",@AppDataDir&"\.minecraft\bin\")
Global $Days[7] = ["Mon","Tue","Wed","Thu","Fri","Sat","Sun"]
Global $Months[12] = ["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sept","Oct","Nov","Dec"]
Global $register = "http://www.minecraft.net/register"

Global $java = _IniRead($ConfigFile,"Java","Path",_GetJavaDir())

If Not FileExists($java) Then
	$msg = MsgBox(276,"Fehler","Java wurde nicht gefunden" & @CRLF & "Fortfahren?")
	If $msg = 6 Then
		$java = FileOpenDialog("Java wurde nicht gefunden!", @ProgramFilesDir & "\", "(*.exe)", 1 ,"java.exe")
		If @error Or Not FileExists($java) Then Exit
	Else
		Exit
	EndIf
EndIf

IniWrite($ConfigFile,"Java","Path",$java)

Global $LastLogin = _GetLastLogin()
Global $minecraft = _IniRead($ConfigFile,"Minecraft","Launch",'"'&$java&'"' & $cmd)

$MAIN_WINDOW = GUICreate("Minecraft Launcher", 870, 519)
GUISetBkColor(0x808080)
$Obj = ObjCreate("Shell.Explorer.2")
GUICtrlCreateObj($Obj,0,0,870, 425)
$Obj.navigate($mcupdate)
$CONTROL_WINDOW = GUICreate("", 870, 93, 0, 426, $WS_CHILD, $WS_EX_TOOLWINDOW, $MAIN_WINDOW)
GUISetBkColor(0x231911)
$Label1 = GUICtrlCreateLabel("Benutzername:", 563, 18, 75, 17)
GUICtrlSetColor(-1, 0xFFFFFF)
$Label2 = GUICtrlCreateLabel("Passwort:", 588, 42, 53, 17)
GUICtrlSetColor(-1, 0xFFFFFF)
$Input1 = GUICtrlCreateInput($LastLogin[0], 645, 16, 121, 21)
$Input2 = GUICtrlCreateInput($LastLogin[1], 645, 40, 121, 21,$ES_PASSWORD)
$Console = GUICtrlCreateCheckbox("", 645, 66, 17, 17)
GUICtrlSetColor(-1, 0xFFFFFF)
$Label3 = GUICtrlCreateLabel("Passwort speichern", 661, 68, 103, 17)
GUICtrlSetColor(-1, 0xFFFFFF)
If $LastLogin[1] <> "" Then GUICtrlSetState($Console,1)
$Button1 = GUICtrlCreateButton("Update", 775, 14, 75, 25)
$Button2 = GUICtrlCreateButton("Login", 775, 38, 75, 25)
$Label4 = GUICtrlCreateLabel("Kein Account?", 775, 68, 78, 17)
GUICtrlSetCursor (-1, 0)
GUICtrlSetFont(-1, 8, 400, 4, "MS Sans Serif")
GUICtrlSetColor(-1, 0x3399FF)
If RegRead("HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Fonts","Minecraft Regular (TrueType)") = "minecraft.ttf" Then
	$Label5 = GUICtrlCreateLabel("Minecraft", 64, 22, 273, 76)
	GUICtrlSetFont(-1, 34, 800,0,"Minecraft")
	GUICtrlSetColor(-1, 0xFFFFFF)
Else
	$Label5 = GUICtrlCreateLabel("Minecraft", 64, 8, 273, 76)
	GUICtrlSetFont(-1, 45, 800)
	GUICtrlSetColor(-1, 0xFFFFFF)
EndIf
GUISetState(@SW_SHOW,$MAIN_WINDOW)
GUISetState(@SW_SHOW,$CONTROL_WINDOW)


While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case -3
			Exit
		Case $Label3
			If GUICtrlRead($Console) = 1 Then
				GUICtrlSetState($Console,4)
			Else
				GUICtrlSetState($Console,1)
			EndIf
		Case $Label4
			$Obj.navigate($register)
		Case $Button2
			$ID = GUICtrlRead($Input1)
			$PW = GUICtrlRead($Input2)
			If Not FileExists($MCPath&"minecraft.jar") Then _Update()
			_Launch($ID,$PW)
		Case $Button1
			_Update()
	EndSwitch
WEnd

Func _IniRead($Filename,$Section,$Key,$Default)
	$return = IniRead($FileName,$Section,$Key,$Default)
	If $return = $Default Then IniWrite($FileName,$Section,$Key,$Default)
	Return $return
EndFunc

Func _GetJavaDir()
	Local $HKLM = "HKLM"
	If @OSArch = "X64" Then $HKLM = "HKLM64"
	$Base = RegRead($HKLM&"\SOFTWARE\JavaSoft\Java Runtime Environment","CurrentVersion")
	If @error Then Return SetError(@error,@extended,$Base)
	$Return = RegRead($HKLM&"\SOFTWARE\JavaSoft\Java Runtime Environment\"&$Base,"JavaHome")
	If @error Then Return SetError(@error,@extended,$Return)
	Return $Return&"\bin\java.exe"
EndFunc

Func _GetLastLogin()
	FileInstall("lastlogin.jar",$MCPath&"\lastlogin.jar")
	Run('"'&$java&'" -Xmx1024M -Xms1024M -jar "'&$MCPath&'lastlogin.jar"',"",@SW_HIDE,0x2)
	$PID = ProcessExists("java.exe")
	$hread = ""
	Do
		$hread&=StdoutRead($PID)
	Until Not ProcessExists($PID)
	FileDelete($MCPath&"lastlogin.jar")
	If Not StringInStr($hread,"|") Then
		Local $ret[2] = ["",""]
		Return $ret
	EndIf
	$hread = StringReplace($hread," ","")
	$hsplit = StringSplit($hread,"|")
	Local $ret[$hsplit[0]]
	For $i = 1 To $hsplit[0]
		$ret[$i-1] = $hsplit[$i]
	Next
	Return $ret
EndFunc

Func _GetMD5s()
	$handle = FileOpen($MCPath&"md5s")
	$read = FileRead($handle)
	$split = StringSplit($read,@CRLF)
	Local $return[$split[0] - 2][2]
	For $i = 3 To $split[0]
		$split2 = StringSplit($return,"=")
		$return[$i-3][0] = $split2[1]
		$return[$i-3][1] = $split2[2]
	Next
	FileClose($handle)
	Return $return
EndFunc

Func _SetMD5s()
	Local $set
	$set = "#md5 hashes for downloaded files"&@CRLF
	$set &= "#"&$Days[@WDAY]&" "&$Months[@MON]&" "&@MDAY&" "&@HOUR&":"&@MIN&":"&@SEC&" CEST "&@YEAR
	For $i = 0 To UBound($gameFiles)-1
		$crypt = StringTrimLeft(_Crypt_HashFile($MCPath&$gameFiles[$i],$CALG_MD5),2)
		$set &= $gameFiles[$i]&"="&$crypt&@CRLF
	Next
	$crypt = StringTrimLeft(_Crypt_HashFile($MCPath&$natives,$CALG_MD5),2)
	$set &= $natives&"="&$crypt
	FileDelete($MCPath&"md5s")
	FileWrite($MCPath&"md5s",$set)
EndFunc

Func _Unzip($hZipFile, $hDestPath)
	If Not FileExists($hDestPath) Then DirCreate($hDestPath)
	Local $aArray[1]
	$oApp = ObjCreate("Shell.Application")
	$oApp.Namespace($hDestPath).CopyHere($oApp.Namespace($hZipFile).Items)
	For $item In $oApp.Namespace($hZipFile).Items
		_ArrayAdd($aArray, $item)
	Next
	While 1
		If ControlGetHandle("[CLASS:#32770]", "", "[CLASS:SysAnimate32; INSTANCE:1]") <> "" And WinGetState("[CLASS:#32770]") <> @SW_HIDE	Then ;The Window Exists
			$hWnd = WinGetHandle("[CLASS:#32770]")
			WinSetState($hWnd, "", @SW_HIDE)
		EndIf
		If FileExists($hDestPath & "\" & $aArray[UBound($aArray) - 1]) Then
			Return SetError(0, 0, 1)
			ExitLoop
		EndIf
		Sleep(500)
	WEnd
EndFunc

Func _UnpackLZMA($FileName)
	Local $Output = StringTrimRight($FileName,9)&".zip"
	DirRemove($MCPath&"natives",1)
	FileInstall("lzma.exe",$MCPath&"lzma.exe",1)
	FileInstall("7z.exe",$MCPath&"7z.exe",1)
	RunWait($MCPath&"lzma.exe d "&$FileName&" "&$Output,$MCPath,@SW_HIDE)
	RunWait($MCPath&"7z.exe e -onatives "&$Output,$MCPath,@SW_HIDE)
	FileDelete($MCPath&"lzma.exe")
	FileDelete($MCPath&"7z.exe")
	FileDelete($MCPath&"windows_natives.jar.lzma")
	FileDelete($MCPath&"windows_natives.zip")
EndFunc

Func _Update()
	ProgressOn("Minecraft Updater","Initializing...","0%")
	For $i = 0 To UBound($gameFiles)-1
		_DownloadPack($gameFiles[$i])
	Next
	_DownloadPack($natives)
	ProgressSet(10*(UBound($gameFiles)+1),10*(UBound($gameFiles)+1)&"%","Entpacke Natives...")
	_UnpackLZMA($MCPath&$natives)
	ProgressSet(10*(UBound($gameFiles)+2),10*(UBound($gameFiles)+2)&"%","Prfen...")
	_SetMD5s()
	ProgressSet(100,"100%")
	ProgressOff()
	MsgBox(64,"Info","Minecraft wurde erfolgreich Upgedated")
EndFunc

Func _Launch($Login,$Password)
	ShellExecute(@ComSpec , "/C java " &$cmd&" "&$Login&" "&$Password,"","",@SW_HIDE)
	WinWait("Minecraft")
	Exit
EndFunc

Func _DownloadPack($Pack)
	$hDownload = InetGet($mcdownload&$Pack,$MCPath&$Pack,1,1)
	Do
		$info = InetGetInfo($hDownload)
		$state = Round($info[0]/$info[1]*100)
		If $state > 0 Then
			ProgressSet($state,$state&"%","Download: "&$Pack)
		Else
			ProgressSet(0,"0%","Download: "&$Pack)
		EndIf
		Sleep(500)
	Until $info[2]
EndFunc